 
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % 
% Author: John-Olav Bratteb, 2014                      %
% Norwegian University of Science and Technology (NTNU) %
% jobrattebo@gmail.com                                  %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % 
 

% close all;
% clear all;

%---  INPUT  ---%
% files = 14069:14245;    % Case 1
% files = 14111:14117;    % Case 1 Testing
% files = 14069:14131;    % Sim
% files = 18519:18801;    % Case 2
files = 31121:31302;    % Case 3
% files = 14069;

savefiles = 1;      %OBS OBS!! UNNG FEIL OVERLAGRING! Sjekk at filename blir rett hvis savefiles skrus p!
%---------------%


% Initialiserer C_map 
% load(['S2_coh_260_220_1425_',num2str(files(1))]); % Case 1
load(['S2_coh_260_250_1425_',num2str(files(1))]); % Case 2 eller 3
C_map = 0.6*abs(coh_sektor(9:3:end,9:8:end-8)); % Raskere konvergering mot riktige verdier
C_map(C_map<1500) = 0;
% [R, Az] = size(coh_sektor);
% C_map=5000*ones(((R-8)/3),(Az/8)-1);
clear coh_sektor R Az
% C_map = [C_map, C_map(:,end)]; % utvid C_map med en kolonne (trengs noen ganger for Case 1)
tic;
for n=files
    disp(['MTD Processing file ' num2str(n) '...'])
    %% INPUT FILE %%
%     logger_fil = ['S2_coh_260_220_1425_',num2str(n)]; % Case 1
%     logger_fil = ['SIM_Swerling1_coh_260_220_1425_',num2str(n)]; % Simuleringsdata Case 1
logger_fil = ['S2_coh_260_250_1425_',num2str(n)]; % Case 2 eller 3

    
    %% Processing
    
    [bbs_norm, bbs_mti, speed, course, UTCtime, ACPrange, WindDir, WindSpd, C_map] = CNav_v10_coh_PPI_JOB(logger_fil,1,C_map);              % v10 CA/OS/OSmex/CACM/OSCM implementert
        
    %% OUTPUT FILE %%
    if savefiles
%         filename = ['ProsessertVrnes/Pros-CA10-MTI0_260_220_1425_',num2str(n)]; % Case 1
%         filename = ['TestPros/Pros-CA8CM10-MTI1_260_220_1425_',num2str(n)]; % Testing Case 1
%         filename = ['SimData/SimS1-CA6CM6-MTI0_260_220_1425_',num2str(n)]; % Case 1 Simuleringsdata
%         filename = ['ProsessertVrnes/Pros-CA6CM6-MTI1_260_250_1425_',num2str(n)]; % Case 2
        filename = ['ProsessertVrnes/Case 3/Pros-OS4CM4-MTI0_260_250_1425_',num2str(n)]; % Case 3
         
        save([filename,'.mat'], 'bbs_mti', 'bbs_norm');    %Lagrer .mat-filer med bbs_mti og bbs_norm variablene
    end
    
end


toc