clear all
close all

numberofbatches = 24;
filesperbatch = 7;

savetrackfigures = 0;
savevideo = 0;

% filename = 'Case1 Tracks CA6 CM6 MTI0 M4 DMHC1 DMUA1 SF1'; % Case 1
filename = 'Case3 Tracks CA6 CM6 MTI0 M4 DMHC1 DMUA1 SF1'; % Case 3
% filename = '5perBatch Case3 Tracks CA6 CM6 MTI0 M4 DMHC1 DMUA1 SF1'; % Case 3   3 out of 5
name_for_fig = '(CA-CFAR, $K_t = 6$)';

ALL_Trackmatrix = [];
ALL_Plotmatrix_c = [];
ALL_MatchedTracks = [];
ALL_tentative_tracks = 0;

No_of_conf_tracks = zeros(1,24);
No_of_tent_tracks = zeros(1,24);

trackfigure = figure();
whitebg('w')
set(gcf,'Color','w')                % Bakgrunnsfarge i ramme
set(gcf,'Position',[400 60 900 900])
imgmap = imread('Map_background2.png');
hold on
imagesc([-5000 5000], [5000 -5000], imgmap)
axis([-4000 4000 -3000 5000])
xlabel('Easting [m]','FontName','Calisto MT', 'FontSize', 14)
ylabel('Northing [m]','FontName','Calisto MT', 'FontSize', 14)
% axis([-3000 -1000 0 2000]) % zoom over fjorden
% zoom case 1
%     axis([-3500 2100 -1100 1700])
%     set(gcf,'Position',[200 60 1050 500])
% zoom case 3
    axis([-3200 1200 -1000 4000]) 
    set(gcf,'Position',[200 60 800 900])
alpha(0.5)

MatchedTracks = [];

for batch = 1:numberofbatches
    load(['Results/' filename '/' filename ' - Batch ' num2str(batch) '.mat'])
%     assignin('base',['Trackmatrix_' num2str(batch)],Trackmatrix);
    ALL_Trackmatrix = [ALL_Trackmatrix; Trackmatrix];
    No_of_conf_tracks(batch)=size(Trackmatrix,1);
%     assignin('base',['Plotmatrix_c_' num2str(batch)],Plotmatrix_c);
    ALL_Plotmatrix_c = [ALL_Plotmatrix_c; Plotmatrix_c];
    ALL_MatchedTracks = MatchedTracks;
%     assignin('base',['tentative_tracks_' num2str(batch)],tentative_tracks);
    ALL_tentative_tracks = ALL_tentative_tracks + tentative_tracks;
    No_of_tent_tracks(batch)=tentative_tracks;
    
    for n=1:size(Trackmatrix,1)
        hold on
        plots=Trackmatrix(n,Trackmatrix(n,:)~=0);
        X=Plotmatrix_c(plots,1);
        Y=Plotmatrix_c(plots,2);
        plot(X,Y,'b')
    end
    if batch ~= 1 && size(MatchedTracks,1) > 0
        for n=1:size(MatchedTracks,1)
            if MatchedTracks(n,1)==batch-1 && MatchedTracks(n,3)==batch
                [~,~,p1]=find(Prev_Trackmatrix(MatchedTracks(n,2),:),1,'last');
                x1 = Prev_Plotmatrix_c(p1,1);
                y1 = Prev_Plotmatrix_c(p1,2);
                [~,~,p2]=find(Trackmatrix(MatchedTracks(n,4),:),1,'last');
                x2 = Plotmatrix_c(p2,1);
                y2 = Plotmatrix_c(p2,2);
                line([x1 x2], [y1 y2],'LineStyle','-','LineWidth',1,'Color','b');
                scatter([x1 x2],[y1 y2],100,'r','Marker','d')
            end
        end
    end
    Prev_Trackmatrix = Trackmatrix;
    Prev_Plotmatrix_c = Plotmatrix_c;
    pause(0.4)
    if savetrackfigures && ismember(batch,1:24)
        set(gcf,'PaperPositionMode','auto');
        saveas(trackfigure, ['Trackfigures/', filename, ' - Batch ', num2str(batch),'.png'], 'png')
    end
end

%% Figures
% Number of tracks per batch
figure, whitebg('white') 
set(gcf,'Color','w')                % Bakgrunnsfarge i ramme
set(gca,'XColor','k')               % X-akse farge
set(gca,'YColor','k')               % Y-akse farge
set(get(gca,'Title'),'Color','k')   % Farge p figur-tittel
set(gcf,'InvertHardcopy','off')     % Lagre figur i farger slik vises (WYSIWYG)
bar(No_of_tent_tracks,'r','LineWidth',1)
hold on
bar(No_of_conf_tracks,'b','LineWidth',1)
title(['Number of tracks per batch ' name_for_fig],'Interpreter','latex','FontName','Calisto MT', 'FontSize', 17)
xlabel('Batch','FontName','Calisto MT', 'FontSize', 15)
ylabel('Tracks','FontName','Calisto MT', 'FontSize', 15)
set(gca,'FontSize',13)
legend1 = legend('Tentative Tracks','Confirmed Tracks','Location', 'NorthWest');
set(legend1,'FontName','Calisto MT', 'FontSize', 15);
set(gcf,'Position',[500 200 900 350])

%% Create video
if savevideo
    disp('Creating .mp4 video...')  %#ok
    % Construct a VideoWriter object
    outputVideo = VideoWriter(fullfile('Trackfigures', [filename '.mp4']),'MPEG-4'); 
    outputVideo.FrameRate = 1;
    open(outputVideo);
    % Loop through the image sequence, load each image and write it to the video.
    for i = 1:numberofbatches
        imfilename = fullfile('Trackfigures',[filename,' - Batch ', num2str(i) '.png']);
        img = imread(imfilename);
        writeVideo(outputVideo,img);
    end
    % Finalize the video file.
    close(outputVideo);
    
    disp('Creating .avi video...')
    % Construct a VideoWriter object
    outputVideo = VideoWriter(fullfile('Trackfigures', [filename '.avi'])); 
    outputVideo.FrameRate = 1;
    open(outputVideo);
    % Loop through the image sequence, load each image and write it to the video.
    for i = 1:numberofbatches
        imfilename = fullfile('Trackfigures',[filename,' - Batch ', num2str(i) '.png']);
        img = imread(imfilename);
        writeVideo(outputVideo,img);
    end
    % Finalize the video file.
    close(outputVideo);
    disp('Finished!')
end
clear filesperbatch numberofbatches Trackmatrix Plotmatrix Plotmatrix_c batch s svar v vr vrd vrdvar vvar tentative_tracks